﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Networking;

public class GameOverLoginManager : MonoBehaviour {

    public GameOverManager gameOverManager;
    public GameObject loginPopupObj;
    public GameObject logoutPopupObj;
    public GameObject needLoginPopup;
    public GameObject needNamePopup;

    public InputField usernameInput;
    public InputField passwordInput;
    public Image usernameInputBg;
    public Image passwordInputBg;

	// Use this for initialization
	void Start () {
        logoutPopupObj = gameOverManager.logoutPopupObj;
        needLoginPopup = gameOverManager.needLoginPopup;
        needNamePopup = gameOverManager.needNamePopup;
	}
	
	// Update is called once per frame
	void Update () {
		
	}

   

    public void loginCancel() {

        loginPopupObj.SetActive(false);

    }

    public void needNameOkay ()
    {
        needNamePopup.SetActive(false);
    }

    public void needLoginLogin ()
    {
        needLoginPopup.SetActive(false);
        loginPopupObj.SetActive(true);
    }

    public void needLoginCancel () {
        needLoginPopup.SetActive(false);
    }

    public void loginSuccess()
    {

        resetUsernameInputColor();
        resetPasswordInputColor();

        PlayerPrefs.SetInt("loggedIn", 1);

        gameOverManager.loggedInText.text = "logged in as: " + PlayerPrefs.GetString("tempUsername") + " (not you?)";
        Debug.Log("hmm1");
        loginPopupObj.SetActive(false);

    }

    public void attemptLogin()
    {

        bool tryLogin = true;

        if (!(usernameInput.text.Length > 0))
        {
            Color tmpCol = usernameInputBg.color;
            tmpCol.r = 1.0f;
            tmpCol.g = 0.6f;
            tmpCol.b = 0.6f;
            tmpCol.a = 0.5f;
            usernameInputBg.color = tmpCol;

            tryLogin = false;
        }

        if (!(passwordInput.text.Length > 0))
        {
            Color tmpCol = passwordInputBg.color;
            tmpCol.r = 1.0f;
            tmpCol.g = 0.6f;
            tmpCol.b = 0.6f;
            tmpCol.a = 0.5f;
            passwordInputBg.color = tmpCol;

            tryLogin = false;
        }

        if (tryLogin)
        {
            PlayerPrefs.SetString("tempUsername", usernameInput.text);
            PlayerPrefs.SetString("tempPassword", passwordInput.text);

            string tempLoginString = "username=";
            tempLoginString = tempLoginString + usernameInput.text;
            tempLoginString = tempLoginString + "&password=" + passwordInput.text;
            Debug.Log("tempLoginString: " + tempLoginString);

            StartCoroutine(TryLogin(tempLoginString));

        //    loginManager.loginButtonPressed();

            //  PlayerPrefs.SetString("tempUsername",usernameInput.text);
            //  PlayerPrefs.SetString("tempPassword",passwordInput.text);

            //  string tempLoginString = "username=";
            //  tempLoginString = tempLoginString+usernameInput.text;
            //  tempLoginString = tempLoginString+"&password="+passwordInput.text;
            //  Debug.Log("tempLoginString: "+tempLoginString);
            //loginManager.loginButtonPressed(tempLoginString);

        }

    }

    IEnumerator TryLogin(string urlAddon)
    {

        string tempUrl = "http://onsetsrimes.com/login_mobile.php?" + urlAddon;

        UnityWebRequest www = UnityWebRequest.Get(tempUrl);
        yield return www.Send();

        if (www.isNetworkError)
        {
            Debug.Log(www.error);
        }
        else
        {
            // Show results as text
            Debug.Log(www.downloadHandler.text);

            string resultString = www.downloadHandler.text;

            if (resultString.Contains("loggedin"))
            {

                // Okay, login was successful...
               loginSuccess();

            }
            else
            {

                loginFailed();

            }

            // Or retrieve results as binary data
            byte[] results = www.downloadHandler.data;
        }
    }

    public void loginFailed()
    {

        Color tmpCol = usernameInputBg.color;
        tmpCol.r = 1.0f;
        tmpCol.g = 0.6f;
        tmpCol.b = 0.6f;
        tmpCol.a = 0.5f;
        usernameInputBg.color = tmpCol;
        passwordInputBg.color = tmpCol;

    }

    public void resetUsernameInputColor()
    {

        Color tmpCol = usernameInputBg.color;
        tmpCol.r = 1.0f;
        tmpCol.g = 1.0f;
        tmpCol.b = 1.0f;
        tmpCol.a = 0.5f;
        usernameInputBg.color = tmpCol;

    }

    public void resetPasswordInputColor()
    {

        Color tmpCol = passwordInputBg.color;
        tmpCol.r = 1.0f;
        tmpCol.g = 1.0f;
        tmpCol.b = 1.0f;
        tmpCol.a = 0.5f;
        passwordInputBg.color = tmpCol;

    }
}
