﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class RimeObject : MonoBehaviour {

	public Image rimeImage;
	public Text rimeText;
	public Text valueText;
	public Button rimeButton;

	public GameObject[] rimes;

	public RimeTop rimeTop;

	public GameController gameController;

	public bool rimePressed = false;

	public float curOpacity = 1.0f;

	// Use this for initialization
	void Start () {
		rimeImage = gameObject.GetComponent<Image>();

		rimeButton = gameObject.GetComponent<Button>();
		rimeButton.onClick.AddListener(rimeSelected);

		rimes = GameObject.FindGameObjectsWithTag("rime");

		rimeTop = GameObject.FindGameObjectWithTag("rime_top").GetComponent<RimeTop>();

		gameController = GameObject.FindGameObjectWithTag("game_controller").GetComponent<GameController>();
	}

	public void rimeSelected() {
        if(!rimePressed && gameController.gameAnimations.finishedRotation) {
			foreach (GameObject rime in rimes){
				rime.GetComponent<RimeObject>().rimePressed = false;
			}
			rimePressed = true;


			rimeTop.rimeText.text = rimeText.text;
			rimeTop.valueText.text = valueText.text;

			//if(!rimeTop.visible){
				rimeTop.shouldShow = true;
				gameController.rimePressed = true;
			//}
		}
	}

	// Update is called once per frame
	void Update () {

		if(rimePressed&&curOpacity>0.5f){
			curOpacity -= 0.1f;
			Color tempColor = rimeImage.color;
			tempColor.a = curOpacity;
			rimeImage.color = tempColor;
		} else if (!rimePressed&&curOpacity<1.0f){
			curOpacity += 0.1f;
			Color tempColor = rimeImage.color;
			tempColor.a = curOpacity;
			rimeImage.color = tempColor;
		}

	}
}
