﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Facebook.Unity;
using UnityEngine.UI;
using Facebook.MiniJSON;
using System.IO;

public class GameOverFacebookManager : MonoBehaviour {

    public string get_data;
    public string fbname;

    //  public HighScoresManager highScoresManager;
    //  public MenuManager menuManager;

    public GameOverManager gameOverManager;
    public Button saveOnlineButton;
    public Text loggedInText;

    public GameObject loginPopup;

    public RawImage gameOverProfileImage;
    //public RawImage highScoreProfileImage;

	// Use this for initialization
	void Start () {
		
	}
	
	// Update is called once per frame
	void Update () {
		
	}

    // Awake function from Unity's MonoBehavior
    void Awake()
    {
        if (!FB.IsInitialized)
        {
            // Initialize the Facebook SDK
            FB.Init(InitCallback, OnHideUnity);
        }
        else
        {
            // Already initialized, signal an app activation App Event
            FB.ActivateApp();
        }
    }

    private void InitCallback()
    {
        if (FB.IsInitialized)
        {
            // Signal an app activation App Event
            FB.ActivateApp();
            // Continue with Facebook SDK
            // ...
        }
        else
        {
            Debug.Log("Failed to Initialize the Facebook SDK");
        }
    }

    private void OnHideUnity(bool isGameShown)
    {
        if (!isGameShown)
        {
            // Pause the game - we will need to hide
            Time.timeScale = 0;
        }
        else
        {
            // Resume the game - we're getting focus again
            Time.timeScale = 1;
        }
    }

    public void attemptLogin() {

        loginPopup.SetActive(false);
        var perms = new List<string>() { "public_profile", "email" };
        FB.LogInWithReadPermissions(perms, AuthCallback);

    }

    private void AuthCallback(ILoginResult result)
    {
        if (FB.IsLoggedIn)
        {
            // AccessToken class will have session details
            var aToken = Facebook.Unity.AccessToken.CurrentAccessToken;
            // Print current access token's User ID
            Debug.Log(aToken.UserId);
            // Print current access token's granted permissions
            foreach (string perm in aToken.Permissions)
            {
                Debug.Log(perm);
                
            }
            FB.API("me?fields=first_name", Facebook.Unity.HttpMethod.GET, NameCallBack);
            FB.API("/me/picture?type=square&height=50&width=50", HttpMethod.GET, UpdateProfileImage);
        }
        else
        {
            Debug.Log("User cancelled login");
        }
    }

    void NameCallBack(IGraphResult result)
    {
         
        string jsonMessage = result.RawResult;
        IDictionary dict = Facebook.MiniJSON.Json.Deserialize(jsonMessage) as IDictionary;
        string fbname = dict["first_name"].ToString();
        Debug.Log(fbname);

        PlayerPrefs.SetString("tempUsername", fbname);
        PlayerPrefs.SetString("tempPassword", "fb");
        PlayerPrefs.SetString("login_type", "fb");
        PlayerPrefs.SetInt("loggedIn", 1);

       // highScoresManager.loginSuccess();
        loggedInText.text = "Logged in as: " + PlayerPrefs.GetString("tempUsername")+ "\n(not you?)";
        saveOnlineButton.enabled = true;
    }

    private void UpdateProfileImage(IGraphResult result)
    {
        if (result.Texture != null)
        {
            gameOverProfileImage.GetComponentInChildren<RawImage>().texture = result.Texture;
        //    highScoreProfileImage.GetComponentInChildren<RawImage>().texture = result.Texture;
            File.WriteAllBytes(Application.persistentDataPath + "/" + "fbprofile.png", (byte[])result.Texture.EncodeToPNG());
        }

    }
}
