﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class HelpAnimations : MonoBehaviour {

	public Image logoImage;
	public Image pageContainerImage;
	public Text titleText;
	public Text titleShadowText;

    public Button helpImagesButton;

    public Button helpLeftArrowButton;
    public Button helpRightArrowButton;

	public Image mainMenuBtnImage;
	public Image newGameBtnImage;

	public bool fadeIn = false;
	public bool fadeOut = false;
	public bool nextPage = false;
	public float curAlpha = 0.0f;
	public bool goBack = false;

	public MenuAnimations menuAnimator;
	public MenuManager menuManager;

    public int helpPageNum = 1;

    public Sprite helpPage1;
    public Sprite helpPage2;
    public Sprite helpPage3;
    public Sprite helpPage4;
    public Sprite helpPage5;

	// Use this for initialization
	void Start () {

		updateColor();

	}

    public void helpLeftArrowPressed() {

        if(helpPageNum == 5){
            helpPageNum = 4;
            helpImagesButton.GetComponent<Image>().sprite = helpPage4;
        } else if (helpPageNum == 4) {
            helpPageNum = 3;
            helpImagesButton.GetComponent<Image>().sprite = helpPage3;
        } else if (helpPageNum == 3) {
            helpPageNum = 2;
            helpImagesButton.GetComponent<Image>().sprite = helpPage2;
        } else if (helpPageNum == 2) {
            helpPageNum = 1;
            helpImagesButton.GetComponent<Image>().sprite = helpPage1;
        }

    }

    public void helpRightArrowPressed() {

        if(helpPageNum == 1){
            helpPageNum = 2;
            helpImagesButton.GetComponent<Image>().sprite = helpPage2;
        } else if (helpPageNum == 2) {
            helpPageNum = 3;
            helpImagesButton.GetComponent<Image>().sprite = helpPage3;
        } else if (helpPageNum == 3) {
            helpPageNum = 4;
            helpImagesButton.GetComponent<Image>().sprite = helpPage4;
        } else if (helpPageNum == 4) {
            helpPageNum = 5;
            helpImagesButton.GetComponent<Image>().sprite = helpPage5;
        }

    }

    public void helpImagePressed() {

        if(helpPageNum == 1){
            helpPageNum = 2;
            helpImagesButton.GetComponent<Image>().sprite = helpPage2;
        } else if (helpPageNum == 2) {
            helpPageNum = 3;
            helpImagesButton.GetComponent<Image>().sprite = helpPage3;
        } else if (helpPageNum == 3) {
            helpPageNum = 4;
            helpImagesButton.GetComponent<Image>().sprite = helpPage4;
        } else if (helpPageNum == 4) {
            helpPageNum = 5;
            helpImagesButton.GetComponent<Image>().sprite = helpPage5;
        }

    }

	// Update is called once per frame
	void Update () {

		if(fadeIn && curAlpha < 1.0f) { 

			curAlpha += 0.05f;

			updateColor();
		
		} else if(fadeOut && curAlpha > 0.0f) {

			curAlpha -= 0.05f;

			updateColor();

		}  else if(fadeOut && !(curAlpha > 0.0f)){

			fadeOut = false;
			if(goBack) { 

				menuAnimator.returnToMenu();
				goBack = false;
				curAlpha = 0.0f;
				fadeIn = false;
				fadeOut = false;

			}

		} else if(fadeIn && !(curAlpha < 1.0f)) {

			fadeIn = false;

		}

	}

	public void backToMenu () {
		
		menuManager.menuObject.SetActive(true);
		fadeIn = false;
		fadeOut = true;
		goBack = true;

	}

	public void updateColor() {

		Color tmpCol = logoImage.color;
		tmpCol.a = curAlpha;
		logoImage.color = tmpCol;

		tmpCol = pageContainerImage.color;
		tmpCol.a = curAlpha;
		pageContainerImage.color = tmpCol;

		tmpCol = titleText.color;
		tmpCol.a = curAlpha;
		titleText.color = tmpCol;

		tmpCol = titleShadowText.color;
		tmpCol.a = curAlpha;
		titleShadowText.color = tmpCol;

		tmpCol = mainMenuBtnImage.color;
		tmpCol.a = curAlpha;
		mainMenuBtnImage.color = tmpCol;

		tmpCol = newGameBtnImage.color;
		tmpCol.a = curAlpha;
		newGameBtnImage.color = tmpCol;

        tmpCol = helpImagesButton.GetComponent<Image>().color;
        tmpCol.a = curAlpha;
        helpImagesButton.GetComponent<Image>().color = tmpCol;

        tmpCol = helpLeftArrowButton.GetComponent<Image>().color;
        tmpCol.a = curAlpha;
        helpLeftArrowButton.GetComponent<Image>().color = tmpCol;

        tmpCol = helpRightArrowButton.GetComponent<Image>().color;
        tmpCol.a = curAlpha;
        helpRightArrowButton.GetComponent<Image>().color = tmpCol;


	}
}
