﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class HighScoresManager : MonoBehaviour {

	public HighScoreAnimations highScoreAnimator;
	public MenuLoginManager loginManager;

	public bool pageEnabled = false;

	public bool onlineScores = false;
	public bool offlineScores = true;

	public bool loginPage = false;
	public bool registerPage = false;

	public GameObject offlineScoresObj;
	public GameObject loginPageObj;
	public GameObject registerPageObj;

	public Image offlineBtnImage;
	public Image onlineBtnImage;
	public Text offlineBtnText;
	public Text onlineBtnText;

	public InputField usernameInput;
	public InputField passwordInput;
	public Image usernameInputBg;
	public Image passwordInputBg;

    public InputField usernameRegisterInput;
    public InputField emailRegisterInput;
    public InputField passwordRegisterInput;
    public Image usernameRegisterInputBg;
    public Image emailRegisterInputBg;
    public Image passwordRegisterInputBg;

    public GameObject bottomButtonObj;
	public Text bottomButtonText;
	public string highScoresString = "";
    public bool freeMode = false;

    public GameObject onlineScoresObj;
    //public UniWebView onlineScoresWebView;

    public GameObject offlineScoresObject;
  //  public HighScoreTest highScoreTestObj;

	// Use this for initialization
	void Start () {

        if (PlayerPrefs.GetInt("free_mode")==1)
        {
            bottomButtonObj.SetActive(false);
            bottomButtonText.text = "";

        }
        else
        {
            bottomButtonObj.SetActive(true);
        }

		string defaultHighScores = "1.Tommy,150/2.Nicole,125/3.Sabrina,100/4.Marlee,75/5.Doug,50";
	//	if(!PlayerPrefs.HasKey("high_scores")){
			PlayerPrefs.SetString("high_scores",defaultHighScores);
			highScoresString = defaultHighScores;
			Debug.Log("wrote defaults");
	//	} else {
	//		highScoresString = PlayerPrefs.GetString("high_scores");
	//		Debug.Log("got defaults");
	//	}
		Debug.Log("highScoresString: "+highScoresString);
		string[] array = highScoresString.Split('/');
		foreach (string token in array) {
			//Debug.Log("string: "+token);
		}
         

        //onlineScoresObj.SetActive(false);
       
	}

	public void loginSuccess () {

		resetUsernameInputColor();
		resetPasswordInputColor();

		PlayerPrefs.SetInt("loggedIn",1);

        bottomButtonText.text = "logged in as: "+PlayerPrefs.GetString("tempUsername")+ " (not you?)";
		onlinePressed();

	}

	public void loginFailed () {

		Color tmpCol = usernameInputBg.color;
		tmpCol.r = 1.0f;
		tmpCol.g = 0.6f;
		tmpCol.b = 0.6f;
		tmpCol.a = 0.5f;
		usernameInputBg.color = tmpCol;
		passwordInputBg.color = tmpCol;

	}

	public void resetUsernameInputColor () {

		Color tmpCol = usernameInputBg.color;
		tmpCol.r = 1.0f;
		tmpCol.g = 1.0f;
		tmpCol.b = 1.0f;
		tmpCol.a = 0.5f;
		usernameInputBg.color = tmpCol;

	}

	public void resetPasswordInputColor () {

		Color tmpCol = passwordInputBg.color;
		tmpCol.r = 1.0f;
		tmpCol.g = 1.0f;
		tmpCol.b = 1.0f;
		tmpCol.a = 0.5f;
		passwordInputBg.color = tmpCol;

	}

    public void attemptRegister() {

        bool tryRegister = true;

        if(!(usernameRegisterInput.text.Length > 0)) {
            Color tmpCol = usernameRegisterInputBg.color;
            tmpCol.r = 1.0f;
            tmpCol.g = 0.6f;
            tmpCol.b = 0.6f;
            tmpCol.a = 0.5f;
            usernameRegisterInputBg.color = tmpCol;
            tryRegister = false;
        }

        if (!(emailRegisterInput.text.Length > 0))
        {
            Color tmpCol = emailRegisterInputBg.color;
            tmpCol.r = 1.0f;
            tmpCol.g = 0.6f;
            tmpCol.b = 0.6f;
            tmpCol.a = 0.5f;
            emailRegisterInputBg.color = tmpCol;
            tryRegister = false;
        }

        if (!(passwordRegisterInput.text.Length > 0))
        {
            Color tmpCol = passwordRegisterInputBg.color;
            tmpCol.r = 1.0f;
            tmpCol.g = 0.6f;
            tmpCol.b = 0.6f;
            tmpCol.a = 0.5f;
            passwordRegisterInputBg.color = tmpCol;
            tryRegister = false;
        }

        if (tryRegister)
        {
            loginManager.registerButtonPressed();
        }

    }

	public void attemptLogin () {

		bool tryLogin = true;

		if(!(usernameInput.text.Length > 0)){
			Color tmpCol = usernameInputBg.color;
			tmpCol.r = 1.0f;
			tmpCol.g = 0.6f;
			tmpCol.b = 0.6f;
			tmpCol.a = 0.5f;
			usernameInputBg.color = tmpCol;

			tryLogin = false;
		}

		if(!(passwordInput.text.Length > 0)){
			Color tmpCol = passwordInputBg.color;
			tmpCol.r = 1.0f;
			tmpCol.g = 0.6f;
			tmpCol.b = 0.6f;
			tmpCol.a = 0.5f;
			passwordInputBg.color = tmpCol;

			tryLogin = false;
		}

		if(tryLogin){

            loginManager.loginButtonPressed();

		//	PlayerPrefs.SetString("tempUsername",usernameInput.text);
		//	PlayerPrefs.SetString("tempPassword",passwordInput.text);

		//	string tempLoginString = "username=";
		//	tempLoginString = tempLoginString+usernameInput.text;
		//	tempLoginString = tempLoginString+"&password="+passwordInput.text;
		//	Debug.Log("tempLoginString: "+tempLoginString);
			//loginManager.loginButtonPressed(tempLoginString);

		}

	}

	public void showPage () {

		if(PlayerPrefs.GetInt("mainMenuLogin")==1||loginPage){ 
			
			loginPage = true;

			Color tmpCol = onlineBtnImage.color;
			tmpCol.a = 1.0f;
			onlineBtnImage.color = tmpCol;

			tmpCol = offlineBtnImage.color;
			tmpCol.a = 1.0f;
			offlineBtnImage.color = tmpCol;

			//scoresPage.SetActive(false);
			registerPageObj.SetActive(false);
			loginPageObj.SetActive(true);

			tmpCol = usernameInputBg.color;
			tmpCol.r = 1.0f;
			tmpCol.g = 1.0f;
			tmpCol.b = 1.0f;
			tmpCol.a = 0.5f;
			usernameInputBg.color = tmpCol;
			passwordInputBg.color = tmpCol;


		} else {

		if(offlineScores) {
                onlineScoresObj.SetActive(false);
                offlineScoresObj.SetActive(true);
			registerPageObj.SetActive(false);
			loginPageObj.SetActive(false);
			//scoresPage.SetActive(true);

			Color tmpCol = offlineBtnImage.color;
                tmpCol.a = 1.0f;
			offlineBtnImage.color = tmpCol;

			tmpCol = onlineBtnImage.color;
                tmpCol.a = 0.5f;
			onlineBtnImage.color = tmpCol;

		}

		if(onlineScores) {
                onlineScoresObj.SetActive(true);
                offlineScoresObj.SetActive(false);
			registerPageObj.SetActive(false);
			loginPageObj.SetActive(false);
			//scoresPage.SetActive(true);

			Color tmpCol = onlineBtnImage.color;
                tmpCol.a = 1.0f;
			onlineBtnImage.color = tmpCol;

			tmpCol = offlineBtnImage.color;
                tmpCol.a = 0.5f;
			offlineBtnImage.color = tmpCol;

		}

		if(registerPage) {

			Color tmpCol = onlineBtnImage.color;
			tmpCol.a = 0.5f;
			onlineBtnImage.color = tmpCol;

			tmpCol = offlineBtnImage.color;
			tmpCol.a = 0.5f;
			offlineBtnImage.color = tmpCol;

			//scoresPage.SetActive(false);
			loginPageObj.SetActive(false);
			registerPageObj.SetActive(true);

		}
		}

	}

	public void offlinePressed () {

        onlineScoresObj.SetActive(false);
        offlineScoresObj.SetActive(true);
		onlineScores = false;
		offlineScores = true;
		loginPage = false;
		registerPage = false;


		showPage();

        Color tmpCol = onlineBtnImage.color;
        tmpCol.a = 0.5f;
        onlineBtnImage.color = tmpCol;

        tmpCol = offlineBtnImage.color;
        tmpCol.a = 1.0f;
        offlineBtnImage.color = tmpCol;


	}

	public void onlinePressed () {
        
        onlineScoresObj.SetActive(true);
        offlineScoresObj.SetActive(false);
    //    onlineScoresWebView.BackgroundColor = Color.clear;
		PlayerPrefs.SetInt("mainMenuLogin",0);
		onlineScores = true;
		offlineScores = false;
		loginPage = false;
		registerPage = false;
		
        showPage();
		//Debug.Log("hmm2");

        Color tmpCol = offlineBtnImage.color;
        tmpCol.a = 0.5f;
        offlineBtnImage.color = tmpCol;

        tmpCol = onlineBtnImage.color;
        tmpCol.a = 1.0f;
        onlineBtnImage.color = tmpCol;


	}

	public void loginPressed () {



        offlineScoresObj.SetActive(false);
        onlineScoresObj.SetActive(false);
		if(PlayerPrefs.GetInt("loggedIn")==0){
			onlineScores = false;
			offlineScores = false;
			loginPage = true;
			registerPage = false;
			showPage();
		} else if(PlayerPrefs.GetInt("loggedIn")==1){
			loginManager.menuManager.logoutPopupObject.SetActive(true);
			loginManager.menuManager.logoutPopupAnimator.fadeIn = true;
		}

	}

	public void registerPressed () {


		onlineScores = false;
		offlineScores = false;
		loginPage = false;
		registerPage = true;
		showPage();

	}

	// Update is called once per frame
	void Update () {
        
	}


}
