﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class LogoutGameOverPopupAnimations : MonoBehaviour {

	public GameOverManager menuManager;

	public Image popupBGImage;
	public Image cancelBtnImage;
	public Image logoutBtnImage;

	public Text popupTitle;
	public Text popupTitleShadow;

	public Text popupWarning;
	public Text popupWarningShadow;

	public float popupAlpha = 0.0f;

	public bool fadeIn = false;
	public bool fadeOut = false;
	public bool visible = false;

	// Use this for initialization
	void Start () {

		//popupAlpha = 0.0f;

	//	changeColors();

	}

	public void cancelPressed () {
	
		fadeIn = false;
		fadeOut = true;
	
	}

	public void logoutPressed () {

		fadeIn = false;
		fadeOut = true;

        menuManager.prevScoreText.text = "";
        menuManager.loggedInText.text = "(not logged in)";
		PlayerPrefs.SetInt("loggedIn",0);
		PlayerPrefs.SetString("tempUsername","");
		PlayerPrefs.SetString("tempPassword","");

	}

	public void changeColors () {

		Color tmpCol = popupBGImage.color;
		tmpCol.a = popupAlpha;
		popupBGImage.color = tmpCol;

		tmpCol = cancelBtnImage.color;
		tmpCol.a = popupAlpha;
		cancelBtnImage.color = tmpCol;

		tmpCol = logoutBtnImage.color;
		tmpCol.a = popupAlpha;
		logoutBtnImage.color = tmpCol;

		tmpCol = popupTitle.color;
		tmpCol.a = popupAlpha;
		popupTitle.color = tmpCol;

		tmpCol = popupTitleShadow.color;
		tmpCol.a = popupAlpha;
		popupTitleShadow.color = tmpCol;

		tmpCol = popupWarning.color;
		tmpCol.a = popupAlpha;
		popupWarning.color = tmpCol;

		tmpCol = popupWarningShadow.color;
		tmpCol.a = popupAlpha;
		popupWarningShadow.color = tmpCol;

	}
	
	// Update is called once per frame
	void Update () {

		if(fadeIn && popupAlpha < 1.0f){

			popupAlpha+=0.1f;
			changeColors();

		} else if(fadeIn && !(popupAlpha < 1.0f)){

			popupAlpha=1.0f;
			changeColors();
			fadeIn = false;
			visible = true;

		} else if(fadeOut && popupAlpha > 0.0f){

			popupAlpha-=0.1f;
			changeColors();

		} else if(fadeOut && !(popupAlpha > 0.0f)){

			popupAlpha=0.0f;
			changeColors();
			fadeOut = false;
			visible = false;
            menuManager.logoutPopupObj.SetActive(false);

		}

	}
}
