﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using System.IO;   

public class OptionsAnimations : MonoBehaviour {

	public Image logoImage;
	public Image pageContainerImage;
	public Text titleText;
	public Text titleShadowText;

	public Text skinsText;
	public Text skinsShadowText;
	public Image classicThemeImg;
	public Image technoThemeImg;
	public Image bambooThemeImg;
	public Image nightThemeImg;
	public Image candyThemeImg;
	public Image pastelThemeImg;

	public Text soundsText;
	public Text soundsShadowText;
	public Image classicSoundImg;
	public Image technoSoundImg;
	public Image bambooSoundImg;
	public Image nightSoundImg;
	public Image candySoundImg;
	public Image pastelSoundImg;

    public Button classicSoundBtn;
    public Button technoSoundBtn;
    public Button bambooSoundBtn;
    public Button nightSoundBtn;
    public Button candySoundBtn;
    public Button pastelSoundBtn;

	public Image mainMenuBtnImage;
	public Image newGameBtnImage;

	public Image volumeBtnImage;

	public bool fadeIn = false;
	public bool fadeOut = false;
	public bool nextPage = false;
	public float curAlpha = 0.0f;
	public bool goBack = false;

	public MenuAnimations menuAnimator;
	public MenuManager menuManager;

	public string current_theme = "classic";
	public string current_sound = "classic";

	public AudioClip sndClassic;
	public AudioClip sndTechno;
	public AudioClip sndBamboo;
	public AudioClip sndNight;
	public AudioClip sndCandy;
	public AudioClip sndPastel;

	public AudioSource sndOptions;

    public Button resetSettingsButton;
    public Image resetSettingsImage;
    public Text resetSettingsText;

    public Button restorePurchasesButton;
    public Image restorePurchasesImage;
    public Text restorePurchasesText;

    public GameObject buyThemesObj;
    public Button buyThemesButton;
    public Image buyThemesImage;
    public Text buyThemesText;

    public GameObject themePreviewObj;
    public Button themePreviewButton;
    public Image themePreviewImage;
    public Text themePreviewText;

    public GameObject previewPopup;
    public GameObject buyPopup;

	// Use this for initialization
	void Start () {

        if(PlayerPrefs.GetInt("free_mode")==1){
           // resetSettingsText.text = "One-Game Theme Preview";
            restorePurchasesText.text = "Restore Purchases";

        } else {
          //  resetSettingsText.text = "Reset Settings";
            restorePurchasesText.text = "Restore Purchases";
        }

        if(PlayerPrefs.GetInt("pro_themes")==1) {
            buyThemesObj.SetActive(false);
            themePreviewObj.SetActive(false);
        } else {
            buyThemesObj.SetActive(true);
            themePreviewObj.SetActive(true);
        }

		if(PlayerPrefs.HasKey("cur_theme")){
			current_theme = PlayerPrefs.GetString("cur_theme");
		} else {
			PlayerPrefs.SetString("cur_theme", "classic");
			current_theme = "classic";
		}

		if(PlayerPrefs.HasKey("cur_sound")){
			current_theme = PlayerPrefs.GetString("cur_sound");
		} else {
			PlayerPrefs.SetString("cur_sound", "classic");
			current_sound = "classic";
		}

		updateColor();
        int volOn = PlayerPrefs.GetInt("volume_on");
        if (volOn == 0)
        {}

	}

    public void previewPopupGo() {

        PlayerPrefs.SetInt("preview_mode", 1);
        previewPopup.SetActive(false);
        menuManager.newGamePressed();

    }

    public void cancelPreviewPopup() {
        previewPopup.SetActive(false);
    }

    public void cancelBuyPopup() {
        buyPopup.SetActive(false);
    }

    public void buyBuyPopup()
    {
        buyPopup.SetActive(false);
    }

    public void optionsThemePreviewPressed() {
        if (PlayerPrefs.GetInt("free_mode") == 1)
        {
            if (PlayerPrefs.GetString("cur_theme") == "classic")
            {

            } else {
                previewPopup.SetActive(true);
            }
        }
    }

    public void optionsNewGamePressed() {

        if (PlayerPrefs.GetInt("free_mode") == 1)
        {
            if(PlayerPrefs.GetString("cur_theme")=="classic"){
                menuManager.newGamePressed();
            } else {
                buyPopup.SetActive(true);
            }                
        } else {
            menuManager.newGamePressed();
        }


    }
		
	// Update is called once per frame
	void Update () {

        int volOn = PlayerPrefs.GetInt("volume_on");
        if (volOn == 0)
        {
            if (curAlpha >= 1.0f)
            {
                classicSoundImg.color = new Color(1.0f, 1.0f, 1.0f, 0.5f);
                technoSoundImg.color = new Color(1.0f, 1.0f, 1.0f, 0.5f);
                bambooSoundImg.color = new Color(1.0f, 1.0f, 1.0f, 0.5f);
                nightSoundImg.color = new Color(1.0f, 1.0f, 1.0f, 0.5f);
                candySoundImg.color = new Color(1.0f, 1.0f, 1.0f, 0.5f);
                pastelSoundImg.color = new Color(1.0f, 1.0f, 1.0f, 0.5f);
                classicSoundBtn.enabled = false;
                technoSoundBtn.enabled = false;
                bambooSoundBtn.enabled = false;
                nightSoundBtn.enabled = false;
                candySoundBtn.enabled = false;
                pastelSoundBtn.enabled = false;
            }
        } else if(volOn== 1){
            if (curAlpha >= 1.0f)
            {
                if (!(PlayerPrefs.GetString("cur_sound") == "classic")) classicSoundImg.color = new Color(1.0f, 1.0f, 1.0f, 1.0f);
                if (!(PlayerPrefs.GetString("cur_sound") == "techno")) technoSoundImg.color = new Color(1.0f, 1.0f, 1.0f, 1.0f);
                if (!(PlayerPrefs.GetString("cur_sound") == "bamboo")) bambooSoundImg.color = new Color(1.0f, 1.0f, 1.0f, 1.0f);
                if (!(PlayerPrefs.GetString("cur_sound") == "night")) nightSoundImg.color = new Color(1.0f, 1.0f, 1.0f, 1.0f);
                if (!(PlayerPrefs.GetString("cur_sound") == "candy")) candySoundImg.color = new Color(1.0f, 1.0f, 1.0f, 1.0f);
                if (!(PlayerPrefs.GetString("cur_sound") == "pastel")) pastelSoundImg.color = new Color(1.0f, 1.0f, 1.0f, 1.0f);
                classicSoundBtn.enabled = true;
                technoSoundBtn.enabled = true;
                bambooSoundBtn.enabled = true;
                nightSoundBtn.enabled = true;
                candySoundBtn.enabled = true;
                pastelSoundBtn.enabled = true;
            }
        }

		if(fadeIn && curAlpha < 1.0f) { 

			curAlpha += 0.1f;

			updateColor();
		
		} else if(fadeOut && curAlpha > 0.0f) {

			curAlpha -= 0.1f;

			updateColor();

		}  else if(fadeOut && !(curAlpha > 0.0f)){

			fadeOut = false;

			if(goBack) { 

				menuAnimator.returnToMenu();
				goBack = false;
				curAlpha = 0.0f;
				fadeIn = false;
				fadeOut = false;

			}

		} else if(fadeIn && !(curAlpha < 1.0f)) { 

			fadeIn = false;
			setThemeButton(current_theme);
			setSoundButton(current_sound);

		}

	}

	public void setClassicTheme () {
		PlayerPrefs.SetString("cur_theme", "classic");
		current_theme = "classic";
		menuManager.current_theme = "classic";
		setThemeButton(current_theme);
		menuManager.setCurrentTheme();
	}

	public void setTechnoTheme () {
		PlayerPrefs.SetString("cur_theme", "techno");
		current_theme = "techno";
		menuManager.current_theme = "techno";
		setThemeButton(current_theme);
		menuManager.setCurrentTheme();
	}

	public void setBambooTheme () {
		PlayerPrefs.SetString("cur_theme", "bamboo");
		current_theme = "bamboo";
		menuManager.current_theme = "bamboo";
		setThemeButton(current_theme);
		menuManager.setCurrentTheme();
	}

	public void setNightTheme () {
		PlayerPrefs.SetString("cur_theme", "night");
		current_theme = "night";
		menuManager.current_theme = "night";
		setThemeButton(current_theme);
		menuManager.setCurrentTheme();
	}

	public void setCandyTheme () {
		PlayerPrefs.SetString("cur_theme", "candy");
		current_theme = "candy";
		menuManager.current_theme = "candy";
		setThemeButton(current_theme);
		menuManager.setCurrentTheme();
	}

	public void setPastelTheme () {
		PlayerPrefs.SetString("cur_theme", "pastel");
		current_theme = "pastel";
		menuManager.current_theme = "pastel";
		setThemeButton(current_theme);
		menuManager.setCurrentTheme();
	}

	public void setClassicSound () {
        int volOn = PlayerPrefs.GetInt("volume_on");
        if (volOn == 1)
        {
            PlayerPrefs.SetString("cur_sound", "classic");
            current_sound = "classic";
            menuManager.current_sound = "classic";
            setSoundButton(current_sound);
            menuManager.setCurrentTheme();
            sndOptions.clip = sndClassic;
       //     int volOn = PlayerPrefs.GetInt("volume_on");
            sndOptions.Play();
        }
	}

	public void setTechnoSound () {
        int volOn = PlayerPrefs.GetInt("volume_on");
        if (volOn == 1)
        {
            PlayerPrefs.SetString("cur_sound", "techno");
            current_sound = "techno";
            menuManager.current_sound = "techno";
            setSoundButton(current_sound);
            menuManager.setCurrentTheme();
            sndOptions.clip = sndTechno;
       //     int volOn = PlayerPrefs.GetInt("volume_on");
            sndOptions.Play();
        }
	}

	public void setBambooSound () {
        int volOn = PlayerPrefs.GetInt("volume_on");
        if (volOn == 1)
        {
            PlayerPrefs.SetString("cur_sound", "bamboo");
            current_sound = "bamboo";
            menuManager.current_sound = "bamboo";
            setSoundButton(current_sound);
            menuManager.setCurrentTheme();
            sndOptions.clip = sndBamboo;
        //    int volOn = PlayerPrefs.GetInt("volume_on");
            sndOptions.Play();
        }
	}

	public void setNightSound () {
        int volOn = PlayerPrefs.GetInt("volume_on");
        if (volOn == 1)
        {
            PlayerPrefs.SetString("cur_sound", "night");
            current_sound = "night";
            menuManager.current_sound = "night";
            setSoundButton(current_sound);
            menuManager.setCurrentTheme();
            sndOptions.clip = sndNight;
         //   int volOn = PlayerPrefs.GetInt("volume_on");
            sndOptions.Play();
        }
	}

	public void setCandySound () {
        int volOn = PlayerPrefs.GetInt("volume_on");
        if (volOn == 1)
        {
            PlayerPrefs.SetString("cur_sound", "candy");
            current_sound = "candy";
            menuManager.current_sound = "candy";
            setSoundButton(current_sound);
            menuManager.setCurrentTheme();
            sndOptions.clip = sndCandy;
          //  int volOn = PlayerPrefs.GetInt("volume_on");
            sndOptions.Play();
        }
	}

	public void setPastelSound () {
        int volOn = PlayerPrefs.GetInt("volume_on");
        if (volOn == 1)
        {
            PlayerPrefs.SetString("cur_sound", "pastel");
            current_sound = "pastel";
            menuManager.current_sound = "pastel";
            setSoundButton(current_sound);
            menuManager.setCurrentTheme();
            sndOptions.clip = sndPastel;
          //  int volOn = PlayerPrefs.GetInt("volume_on");
            sndOptions.Play();
        }
	}

	public void resetThemeButtons () {
		Color tmpColor = classicThemeImg.color;
		tmpColor.a = 1.0f;
		classicThemeImg.color = tmpColor;
		tmpColor = technoThemeImg.color;
		tmpColor.a = 1.0f;
		technoThemeImg.color = tmpColor;
		tmpColor = bambooThemeImg.color;
		tmpColor.a = 1.0f;
		bambooThemeImg.color = tmpColor;
		tmpColor = nightThemeImg.color;
		tmpColor.a = 1.0f;
		nightThemeImg.color = tmpColor;
		tmpColor = candyThemeImg.color;
		tmpColor.a = 1.0f;
		candyThemeImg.color = tmpColor;
		tmpColor = pastelThemeImg.color;
		tmpColor.a = 1.0f;
		pastelThemeImg.color = tmpColor;
	}

	public void resetSoundButtons () {
		Color tmpColor = classicSoundImg.color;
		tmpColor.a = 1.0f;
		classicSoundImg.color = tmpColor;
		tmpColor = technoSoundImg.color;
		tmpColor.a = 1.0f;
		technoSoundImg.color = tmpColor;
		tmpColor = bambooSoundImg.color;
		tmpColor.a = 1.0f;
		bambooSoundImg.color = tmpColor;
		tmpColor = nightSoundImg.color;
		tmpColor.a = 1.0f;
		nightSoundImg.color = tmpColor;
		tmpColor = candySoundImg.color;
		tmpColor.a = 1.0f;
		candySoundImg.color = tmpColor;
		tmpColor = pastelSoundImg.color;
		tmpColor.a = 1.0f;
		pastelSoundImg.color = tmpColor;
	}

	public void setThemeButton (string themeName) {

		resetThemeButtons();

		Color tmpColor;

		if(PlayerPrefs.GetString("cur_theme").Equals("classic")){
			tmpColor = classicThemeImg.color;
			tmpColor.a = 0.5f;
			classicThemeImg.color = tmpColor;
		} else if(PlayerPrefs.GetString("cur_theme").Equals("techno")){
			tmpColor = technoThemeImg.color;
			tmpColor.a = 0.5f;
			technoThemeImg.color = tmpColor;
		} else if(PlayerPrefs.GetString("cur_theme").Equals("bamboo")){
			tmpColor = bambooThemeImg.color;
			tmpColor.a = 0.5f;
			bambooThemeImg.color = tmpColor;
		} else if(PlayerPrefs.GetString("cur_theme").Equals("night")){
			tmpColor = nightThemeImg.color;
			tmpColor.a = 0.5f;
			nightThemeImg.color = tmpColor;
		} else if(PlayerPrefs.GetString("cur_theme").Equals("candy")){
			tmpColor = candyThemeImg.color;
			tmpColor.a = 0.5f;
			candyThemeImg.color = tmpColor;
		} else if(PlayerPrefs.GetString("cur_theme").Equals("pastel")){
			tmpColor = pastelThemeImg.color;
			tmpColor.a = 0.5f;
			pastelThemeImg.color = tmpColor;
		} 

	}

	public void setSoundButton (string soundName) {

		resetSoundButtons();

		Color tmpColor;

		if(PlayerPrefs.GetString("cur_sound").Equals("classic")){
			tmpColor = classicSoundImg.color;
			tmpColor.a = 0.5f;
			classicSoundImg.color = tmpColor;
		} else if(PlayerPrefs.GetString("cur_sound").Equals("techno")){
			tmpColor = technoSoundImg.color;
			tmpColor.a = 0.5f;
			technoSoundImg.color = tmpColor;
		} else if(PlayerPrefs.GetString("cur_sound").Equals("bamboo")){
			tmpColor = bambooSoundImg.color;
			tmpColor.a = 0.5f;
			bambooSoundImg.color = tmpColor;
		} else if(PlayerPrefs.GetString("cur_sound").Equals("night")){
			tmpColor = nightSoundImg.color;
			tmpColor.a = 0.5f;
			nightSoundImg.color = tmpColor;
		} else if(PlayerPrefs.GetString("cur_sound").Equals("candy")){
			tmpColor = candySoundImg.color;
			tmpColor.a = 0.5f;
			candySoundImg.color = tmpColor;
		} else if(PlayerPrefs.GetString("cur_sound").Equals("pastel")){
			tmpColor = pastelSoundImg.color;
			tmpColor.a = 0.5f;
			pastelSoundImg.color = tmpColor;
		} 

	}

	public void backToMenu () {

        if (PlayerPrefs.GetInt("free_mode") == 1)
        {
            setClassicTheme();
        } else {
            
        }

        if (PlayerPrefs.GetInt("pro_themes") == 1)
        {

        } else  {
            setClassicSound();
        }

		menuManager.menuObject.SetActive(true);
		fadeIn = false;
		fadeOut = true;
		goBack = true;

	}

	public void updateColor() {

		Color tmpCol = logoImage.color;
		tmpCol.a = curAlpha;
		logoImage.color = tmpCol;

		tmpCol = pageContainerImage.color;
		tmpCol.a = curAlpha;
		pageContainerImage.color = tmpCol;

		tmpCol = titleText.color;
		tmpCol.a = curAlpha;
		titleText.color = tmpCol;

		tmpCol = titleShadowText.color;
		tmpCol.a = curAlpha;
		titleShadowText.color = tmpCol;

		tmpCol = mainMenuBtnImage.color;
		tmpCol.a = curAlpha;
		mainMenuBtnImage.color = tmpCol;

		tmpCol = newGameBtnImage.color;
		tmpCol.a = curAlpha;
		newGameBtnImage.color = tmpCol;

		tmpCol = skinsText.color;
		tmpCol.a = curAlpha;
		skinsText.color = tmpCol;

		tmpCol = skinsShadowText.color;
		tmpCol.a = curAlpha;
		skinsShadowText.color = tmpCol;

		tmpCol = classicThemeImg.color;
		tmpCol.a = curAlpha;
		classicThemeImg.color = tmpCol;

		tmpCol = technoThemeImg.color;
		tmpCol.a = curAlpha;
		technoThemeImg.color = tmpCol;

		tmpCol = bambooThemeImg.color;
		tmpCol.a = curAlpha;
		bambooThemeImg.color = tmpCol;

		tmpCol = nightThemeImg.color;
		tmpCol.a = curAlpha;
		nightThemeImg.color = tmpCol;

		tmpCol = candyThemeImg.color;
		tmpCol.a = curAlpha;
		candyThemeImg.color = tmpCol;

		tmpCol = pastelThemeImg.color;
		tmpCol.a = curAlpha;
		pastelThemeImg.color = tmpCol;

		tmpCol = soundsText.color;
		tmpCol.a = curAlpha;
		soundsText.color = tmpCol;

		tmpCol = soundsShadowText.color;
		tmpCol.a = curAlpha;
		soundsShadowText.color = tmpCol;

		tmpCol = classicSoundImg.color;
		tmpCol.a = curAlpha;
		classicSoundImg.color = tmpCol;

		tmpCol = technoSoundImg.color;
		tmpCol.a = curAlpha;
		technoSoundImg.color = tmpCol;

		tmpCol = bambooSoundImg.color;
		tmpCol.a = curAlpha;
		bambooSoundImg.color = tmpCol;

		tmpCol = nightSoundImg.color;
		tmpCol.a = curAlpha;
		nightSoundImg.color = tmpCol;

		tmpCol = candySoundImg.color;
		tmpCol.a = curAlpha;
		candySoundImg.color = tmpCol;

		tmpCol = pastelSoundImg.color;
		tmpCol.a = curAlpha;
		pastelSoundImg.color = tmpCol;

		tmpCol = volumeBtnImage.color;
		tmpCol.a = curAlpha;
		volumeBtnImage.color = tmpCol;

        tmpCol = resetSettingsImage.color;
        tmpCol.a = curAlpha/8;
        resetSettingsImage.color = tmpCol;

        tmpCol = resetSettingsText.color;
        tmpCol.a = curAlpha;
        resetSettingsText.color = tmpCol;

        tmpCol = restorePurchasesImage.color;
        tmpCol.a = curAlpha/8;
        restorePurchasesImage.color = tmpCol;

        tmpCol = restorePurchasesText.color;
        tmpCol.a = curAlpha;
        restorePurchasesText.color = tmpCol;

        tmpCol = buyThemesImage.color;
        tmpCol.a = curAlpha / 8;
        buyThemesImage.color = tmpCol;

        tmpCol = buyThemesText.color;
        tmpCol.a = curAlpha;
        buyThemesText.color = tmpCol;

        tmpCol = themePreviewImage.color;
        tmpCol.a = curAlpha / 8;
        themePreviewImage.color = tmpCol;

        tmpCol = themePreviewText.color;
        tmpCol.a = curAlpha;
        themePreviewText.color = tmpCol;



	}

    public void resetSettings () {
        
    }

    public void restorePurchases ()
    {

    }

	public void changeImageColor (Image tempImage) {

		Color tmpCol = tempImage.color;
		tmpCol.a = curAlpha;
		tempImage.color = tmpCol;

	}

	public void changeTextColor (Text tempText) {

		Color tmpCol = tempText.color;
		tmpCol.a = curAlpha;
		tempText.color = tmpCol;

	}
}
